package org.jboss.security.srp;

package .tmp;

import java.io.Serializable;
import java.lang.reflect.InvocationHandler;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import org.jboss.security.srp.SRPServerInterface;

public class SRPServerProxy implements InvocationHandler, Serializable {
  private static final long serialVersionUID = 5255628656806648070L;
  
  private SRPServerInterface server;
  
  SRPServerProxy(SRPServerInterface server) {
    this.server = server;
  }
  
  public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
    Object ret = null;
    try {
      ret = method.invoke(this.server, args);
    } catch (InvocationTargetException e) {
      throw e.getTargetException();
    } catch (Throwable e) {
      e.printStackTrace();
      throw e;
    } 
    return ret;
  }
}
